Loading...
Searching...
No Matches
BALL::Composite Class Reference
Foundation Classes » Concepts » Miscellaneous

`#include <BALL/CONCEPT/composite.h>`

Inheritance diagram for BALL::Composite:

## Classes

class | AncestorIteratorTraits
class | ChildCompositeIteratorTraits
class | CompositeIteratorTraits

## Public Member Functions

template<typename T>
BALL_INLINE bool | apply (UnaryProcessor< T > &processor)
template<typename T>
BALL_INLINE bool | apply (ConstUnaryProcessor< T > &processor) const
template<typename T>
BALL_INLINE T * | getAncestor (const T &)
template<typename T>
BALL_INLINE const T * | getAncestor (const T &) const
template<typename T>
BALL_INLINE T * | getPrevious (const T &)
template<typename T>
BALL_INLINE const T * | getPrevious (const T &dummy) const
template<typename T>
BALL_INLINE T * | getNext (const T &)
template<typename T>
BALL_INLINE const T * | getNext (const T &dummy) const
template<typename T>
BALL_INLINE bool | hasAncestor (const T &dummy) const
Construction and Destruction
| Composite ()
| Composite (const Composite &composite, bool deep=true)
virtual | ~Composite ()
virtual void | clear ()
virtual void | destroy ()
void | destroy (bool virtual_destroy)
void * | clone (Composite &root) const
Persistence
virtual void | persistentWrite (PersistenceManager &pm, const char *name=0) const
virtual void | persistentRead (PersistenceManager &pm)
Predicates
bool | operator== (const Composite &composite) const
bool | operator!= (const Composite &composite) const
bool | isEmpty () const
bool | isRoot () const
bool | isRootOf (const Composite &composite) const
bool | isInterior () const
bool | hasChild () const
bool | isChildOf (const Composite &composite) const
bool | isFirstChild () const
bool | isFirstChildOf (const Composite &composite) const
bool | isLastChild () const
bool | isLastChildOf (const Composite &composite) const
bool | hasParent () const
bool | isParentOf (const Composite &composite) const
bool | hasSibling () const
bool | isSiblingOf (const Composite &composite) const
bool | hasPreviousSibling () const
bool | isPreviousSiblingOf (const Composite &composite) const
bool | hasNextSibling () const
bool | isNextSiblingOf (const Composite &composite) const
bool | isDescendantOf (const Composite &composite) const
template<typename T>
bool | hasAncestor (const T &dummy) const
bool | isAncestorOf (const Composite &composite) const
bool | isRelatedWith (const Composite &composite) const
bool | isHomomorph (const Composite &composite) const
bool | containsSelection () const
Type predicates
These predicates should be used for type checking instead of dynamic_casts as a virtual function call is orders of magnitudes faster.
virtual bool | isAtom () const
virtual bool | isMolecule () const
virtual bool | isProtein () const
virtual bool | isFragment () const
virtual bool | isResidue () const
virtual bool | isChain () const
Debugging and Diagnostics
virtual bool | isValid () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
Public Member Functions inherited from BALL::PersistentObject
| PersistentObject ()
virtual | ~PersistentObject ()
PersistenceManager & | operator>> (PersistenceManager &pm) const
virtual void | finalize ()
Public Member Functions inherited from BALL::Object
| Object ()
| Default constructor.
| Object (const Object &object)
| Copy constructor.
virtual | ~Object ()
| Destructor.
const Object & | operator= (const Object &)
bool | operator== (const Object &object) const
bool | operator!= (const Object &object) const
bool | operator< (const Object &object) const
bool | operator<= (const Object &object) const
bool | operator>= (const Object &object) const
bool | operator> (const Object &object) const
int | compare (const Object &object) const
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const
Handle | getHandle () const
Public Member Functions inherited from BALL::AutoDeletable
virtual | ~AutoDeletable ()
void * | operator new (size_t size)
void | operator delete (void *ptr)
void * | operator new (size_t size, void *ptr)
void | operator delete (void *ptr, void *)
bool | isAutoDeletable () const
void | setAutoDeletable (bool enable)
Public Member Functions inherited from BALL::Selectable
| Selectable ()
| Selectable (const Selectable &selectable, bool deep=true)
virtual | ~Selectable ()
void | set (const Selectable &selectable, bool deep=true)
const Selectable & | operator= (const Selectable &selectable)
void | get (Selectable &selectable, bool deep=true) const
void | swap (Selectable &selectable)
virtual void | setSelected (bool selected)
bool | isSelected () const
bool | operator== (const Selectable &selectable) const
bool | operator!= (const Selectable &selectable) const
void | write (PersistenceManager &pm) const
bool | read (PersistenceManager &pm)
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const

## Type Definitions and Enums

enum | StampType { MODIFICATION = 1 , SELECTION = 2 , BOTH = 3 }
typedef UnaryPredicate< Composite > | KernelPredicateType
static UnaryProcessor< Composite > | DEFAULT_PROCESSOR
static KernelPredicateType | DEFAULT_UNARY_PREDICATE

## Application and Hosting

typedef ForwardIterator< Composite, Composite, Composite *, AncestorIteratorTraits > | AncestorIterator
typedef ConstForwardIterator< Composite, Composite, Composite *, AncestorIteratorTraits > | AncestorConstIterator
typedef BidirectionalIterator< Composite, Composite, Composite *, ChildCompositeIteratorTraits > | ChildCompositeIterator
typedef ConstBidirectionalIterator< Composite, Composite, Composite *, ChildCompositeIteratorTraits > | ChildCompositeConstIterator
typedef std::reverse_iterator< ChildCompositeIterator > | ChildCompositeReverseIterator
typedef std::reverse_iterator< ChildCompositeConstIterator > | ChildCompositeConstReverseIterator
typedef BidirectionalIterator< Composite, Composite, Composite *, CompositeIteratorTraits > | CompositeIterator
typedef ConstBidirectionalIterator< Composite, Composite, Composite *, CompositeIteratorTraits > | CompositeConstIterator
typedef std::reverse_iterator< CompositeIterator > | CompositeReverseIterator
typedef std::reverse_iterator< CompositeConstIterator > | CompositeConstReverseIterator
class | AncestorIteratorTraits
class | ChildCompositeIteratorTraits
class | CompositeIteratorTraits
void | host (Visitor< Composite > &visitor)
template<typename T>
bool | applyAncestor (UnaryProcessor< T > &processor)
template<typename T>
bool | applyAncestor (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyChild (UnaryProcessor< T > &processor)
template<typename T>
bool | applyChild (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendantPreorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendantPreorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendantPostorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendantPostorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyDescendant (UnaryProcessor< T > &processor)
template<typename T>
bool | applyDescendant (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyPreorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyPreorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyPostorder (UnaryProcessor< T > &processor)
template<typename T>
bool | applyPostorder (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | apply (UnaryProcessor< T > &processor)
template<typename T>
bool | apply (ConstUnaryProcessor< T > &processor) const
template<typename T>
bool | applyLevel (UnaryProcessor< T > &processor, long level)
template<typename T>
bool | applyLevel (ConstUnaryProcessor< T > &processor, long level) const
AncestorIterator | beginAncestor ()
AncestorIterator | endAncestor ()
AncestorConstIterator | beginAncestor () const
AncestorConstIterator | endAncestor () const
ChildCompositeIterator | beginChildComposite ()
ChildCompositeIterator | endChildComposite ()
ChildCompositeConstIterator | beginChildComposite () const
ChildCompositeConstIterator | endChildComposite () const
ChildCompositeReverseIterator | rbeginChildComposite ()
ChildCompositeReverseIterator | rendChildComposite ()
ChildCompositeConstReverseIterator | rbeginChildComposite () const
ChildCompositeConstReverseIterator | rendChildComposite () const
CompositeIterator | beginComposite ()
CompositeIterator | endComposite ()
CompositeConstIterator | beginComposite () const
CompositeConstIterator | endComposite () const
CompositeReverseIterator | rbeginComposite ()
CompositeReverseIterator | rendComposite ()
CompositeConstReverseIterator | rbeginComposite () const
CompositeConstReverseIterator | rendComposite () const
void | deleteChildrenList_ (std::list< Composite * > &composites)

## Modifying and Accessing the Tree

void | set (const Composite &composite, bool deep=true)
Composite & | operator= (const Composite &composite)
void | get (Composite &composite, bool deep=true) const
Size | getDegree () const
Size | count (const KernelPredicateType &predicate) const
Size | countDescendants () const
Size | getPathLength (const Composite &composite) const
Size | getDepth () const
Size | getHeight () const
Composite & | getRoot ()
const Composite & | getRoot () const
Composite * | getLowestCommonAncestor (const Composite &composite)
const Composite * | getLowestCommonAncestor (const Composite &composite) const
template<typename T>
T * | getAncestor (const T &)
template<typename T>
const T * | getAncestor (const T &) const
template<typename T>
T * | getPrevious (const T &)
template<typename T>
const T * | getPrevious (const T &dummy) const
template<typename T>
T * | getNext (const T &)
template<typename T>
const T * | getNext (const T &dummy) const
Composite * | getParent ()
const Composite * | getParent () const
Composite * | getChild (Index index)
const Composite * | getChild (Index index) const
Composite * | getSibling (Index index)
const Composite * | getSibling (Index index) const
Composite * | getFirstChild ()
const Composite * | getFirstChild () const
Composite * | getLastChild ()
const Composite * | getLastChild () const
const PreciseTime & | getModificationTime () const
const PreciseTime & | getSelectionTime () const
void | stamp (StampType stamp=BOTH)
void | prependChild (Composite &composite)
void | appendChild (Composite &composite)
void | insertBefore (Composite &composite)
void | insertAfter (Composite &composite)
void | spliceBefore (Composite &composite)
void | spliceAfter (Composite &composite)
void | splice (Composite &composite)
bool | removeChild (Composite &child)
Size | removeSelected ()
Size | removeUnselected ()
void | replace (Composite &composite)
void | swap (Composite &composite)
virtual void | select ()
virtual void | deselect ()
static bool | insertParent (Composite &parent, Composite &first, Composite &last, bool destroy_parent=true)

## Additional Inherited Members

static Handle | getNextHandle ()
static Handle | getNewHandle ()
static void | clearLastPtr ()
| AutoDeletable ()
| AutoDeletable (const AutoDeletable &auto_deletable, bool deep=false)
bool | selected_

## Detailed Description

Composite Class. This class implements a variant of the composite design pattern. A Composite may contain an arbitrary number of other composites, thus forming a tree. All BALL kernel classes are derived from Composite. This provides a unique interface for all kernel classes.

  The composite class provides a selection mechanism that allows hierarchical selection and deselection of arbitrary subtrees. The time of the last selection/deselection operation is stored as well as the time of the last modification operation in time stamps that can be accessed via getModificationTime
  and getSelectionTime . Selecting or deselecting a Composite automatically selects or deselects all its children (recursively!). Selecting or deselecting all children of a node deselects their parent as well. Selection information is propagated upwards in the tree.

  Composites are persistent objects.

Definition at line 71 of file composite.h.

## Member Typedef Documentation

## AncestorConstIterator

typedef ConstForwardIterator<Composite, Composite, Composite*, AncestorIteratorTraits> BALL::Composite::AncestorConstIterator

Definition at line 1064 of file composite.h.

## AncestorIterator

typedef ForwardIterator<Composite, Composite, Composite*, AncestorIteratorTraits> BALL::Composite::AncestorIterator

Definition at line 1051 of file composite.h.

## ChildCompositeConstIterator

typedef ConstBidirectionalIterator<Composite, Composite, Composite *, ChildCompositeIteratorTraits> BALL::Composite::ChildCompositeConstIterator

Definition at line 1188 of file composite.h.

## ChildCompositeConstReverseIterator

typedef std::reverse_iterator<ChildCompositeConstIterator> BALL::Composite::ChildCompositeConstReverseIterator

Definition at line 1218 of file composite.h.

## ChildCompositeIterator

typedef BidirectionalIterator<Composite, Composite, Composite *, ChildCompositeIteratorTraits> BALL::Composite::ChildCompositeIterator

Definition at line 1171 of file composite.h.

## ChildCompositeReverseIterator

typedef std::reverse_iterator<ChildCompositeIterator> BALL::Composite::ChildCompositeReverseIterator

Definition at line 1204 of file composite.h.

## CompositeConstIterator

typedef ConstBidirectionalIterator<Composite, Composite, Composite*, CompositeIteratorTraits> BALL::Composite::CompositeConstIterator

Definition at line 1475 of file composite.h.

## CompositeConstReverseIterator

typedef std::reverse_iterator<CompositeConstIterator> BALL::Composite::CompositeConstReverseIterator

Definition at line 1501 of file composite.h.

## CompositeIterator

typedef BidirectionalIterator<Composite, Composite, Composite*, CompositeIteratorTraits> BALL::Composite::CompositeIterator

Definition at line 1468 of file composite.h.

## CompositeReverseIterator

typedef std::reverse_iterator<CompositeIterator> BALL::Composite::CompositeReverseIterator

Definition at line 1488 of file composite.h.

## KernelPredicateType

typedef UnaryPredicate<Composite> BALL::Composite::KernelPredicateType

Composite predicate type. This type declares a predicate operating on composites. As it is used as a predicate for all kernel classes, it is named KernelPredicateType.

Definition at line 88 of file composite.h.

## Member Enumeration Documentation

## StampType

enum BALL::Composite::StampType

Time stamp type.

Enumerator
MODIFICATION |
SELECTION |
BOTH |

Definition at line 93 of file composite.h.

## Constructor & Destructor Documentation

## Composite() [1/2]

BALL::Composite::Composite | ( |  | ) |

Default constructor. This constructor creates an empty composite object.

## Composite() [2/2]

BALL::Composite::Composite | ( | const Composite & | composite,
|  | bool | deep = true )

Copy constructor. Creates a copy of a composite. Deep copies include the whole composite tree, shallow copies contain anly a single composite.

Parameters

  composite | the composite to be cloned (the root of the tree in the case of a deep copy)
  deep | make a deep copy (true) or shallow copy (false)

## ~Composite()

virtual BALL::Composite::~Composite | ( |  | ) |

virtual

Destructor. The destructor calls destroy to remove the composite from potential tree structures. It also recursively destructs all children of the composite.

## Member Function Documentation

## appendChild()

void BALL::Composite::appendChild | ( | Composite & | composite | ) |

Insert a composite as the last child of this composite. Updates the modification time stamp. Note that this method alters the composite tree from which composite is taken, if there is such a tree.

See also
  stamp

Parameters

  composite | the composite to be inserted

## apply() [1/4]

template<typename T>

BALL_INLINE bool BALL::Composite::apply | ( | ConstUnaryProcessor< T > & | processor | ) | const

Definition at line 2056 of file composite.h.

## apply() [2/4]

template<typename T>

bool BALL::Composite::apply | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to the node and its subtree. applyPreorder is used.

See also
  applyPreorder

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

## apply() [3/4]

template<typename T>

BALL_INLINE bool BALL::Composite::apply | ( | UnaryProcessor< T > & | processor | ) |

Definition at line 2049 of file composite.h.

## apply() [4/4]

template<typename T>

bool BALL::Composite::apply | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to the node and its subtree. applyPreorder is used.

See also
  applyPreorder

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

## applyAncestor() [1/2]

template<typename T>

bool BALL::Composite::applyAncestor | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to all ancestors of this node.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1626 of file composite.h.

## applyAncestor() [2/2]

template<typename T>

bool BALL::Composite::applyAncestor | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to all ancestors of this node.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1600 of file composite.h.

## applyChild() [1/2]

template<typename T>

bool BALL::Composite::applyChild | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to all children of this node.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1658 of file composite.h.

## applyChild() [2/2]

template<typename T>

bool BALL::Composite::applyChild | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to all children of this node.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1652 of file composite.h.

## applyDescendant() [1/2]

template<typename T>

bool BALL::Composite::applyDescendant | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to all descendents of this node. The node itself is not processed. applyDescendantPreorder is used.

See also
  applyDescendantPreorder

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 2030 of file composite.h.

## applyDescendant() [2/2]

template<typename T>

bool BALL::Composite::applyDescendant | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to all descendents of this node. The node itself is not processed. applyDescendantPreorder is used.

See also
  applyDescendantPreorder

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 2024 of file composite.h.

## applyDescendantPostorder() [1/2]

template<typename T>

bool BALL::Composite::applyDescendantPostorder | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to all descendents of this node. The node itself is not processed. The root of a subtree is accessed after the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1782 of file composite.h.

## applyDescendantPostorder() [2/2]

template<typename T>

bool BALL::Composite::applyDescendantPostorder | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to all descendents of this node. The node itself is not processed. The root of a subtree is accessed after the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1776 of file composite.h.

## applyDescendantPreorder() [1/2]

template<typename T>

bool BALL::Composite::applyDescendantPreorder | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to all descendents of this node. The node itself is not processed. The root of a subtree is accessed before the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1714 of file composite.h.

## applyDescendantPreorder() [2/2]

template<typename T>

bool BALL::Composite::applyDescendantPreorder | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to all descendents of this node. The node itself is not processed. The root of a subtree is accessed before the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1708 of file composite.h.

## applyLevel() [1/2]

template<typename T>

bool BALL::Composite::applyLevel | ( | ConstUnaryProcessor< T > & | processor,
|  | long | level ) const

Apply a const processor to the node and its siblings.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1883 of file composite.h.

## applyLevel() [2/2]

template<typename T>

bool BALL::Composite::applyLevel | ( | UnaryProcessor< T > & | processor,
|  | long | level )

Apply a processor to the node and its siblings.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1877 of file composite.h.

## applyPostorder() [1/2]

template<typename T>

bool BALL::Composite::applyPostorder | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to the node and its subtree. The root of a subtree is accessed after the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1861 of file composite.h.

## applyPostorder() [2/2]

template<typename T>

bool BALL::Composite::applyPostorder | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to the node and its subtree. The root of a subtree is accessed after the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 1846 of file composite.h.

## applyPreorder() [1/2]

template<typename T>

bool BALL::Composite::applyPreorder | ( | ConstUnaryProcessor< T > & | processor | ) | const

Apply a const processor to the node and its subtree. The root of a subtree is accessed before the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 2042 of file composite.h.

## applyPreorder() [2/2]

template<typename T>

bool BALL::Composite::applyPreorder | ( | UnaryProcessor< T > & | processor | ) |

Apply a processor to the node and its subtree. The root of a subtree is accessed before the nodes in its left and right subtree.

Returns
  true if the processor could be applied.

Exceptions

  Exception::GeneralException |

Definition at line 2036 of file composite.h.

## beginAncestor() [1/2]

AncestorIterator BALL::Composite::beginAncestor | ( |  | ) |

inline

Definition at line 1053 of file composite.h.

## beginAncestor() [2/2]

AncestorConstIterator BALL::Composite::beginAncestor | ( |  | ) | const

inline

Definition at line 1066 of file composite.h.

## beginChildComposite() [1/2]

ChildCompositeIterator BALL::Composite::beginChildComposite | ( |  | ) |

inline

Definition at line 1173 of file composite.h.

## beginChildComposite() [2/2]

ChildCompositeConstIterator BALL::Composite::beginChildComposite | ( |  | ) | const

inline

Definition at line 1190 of file composite.h.

## beginComposite() [1/2]

CompositeIterator BALL::Composite::beginComposite | ( |  | ) |

inline

Definition at line 1470 of file composite.h.

## beginComposite() [2/2]

CompositeConstIterator BALL::Composite::beginComposite | ( |  | ) | const

inline

Definition at line 1477 of file composite.h.

## clear()

virtual void BALL::Composite::clear | ( |  | ) |

virtual

Clear the composite properties. This method removes the composite's children and destructs them if they are auto-deletable.

  It does not remove the composite from any parental structure.

  This method updates the modification time stamp of this.

See also
  stamp
  AutoDeletable
  destroy

Reimplemented from BALL::Object.

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, and BALL::SecondaryStructure.

## clone()

void * BALL::Composite::clone | ( | Composite & | root | ) | const

Clone with a predicate. This method copies the attributes of this composite to root (shallow copy) and then adds recursively each of its children.

Parameters

  root | the cloning target root is destroyed prior to any copying

Returns
  a pointer to the root composite (&root)

## containsSelection()

bool BALL::Composite::containsSelection | ( |  | ) | const

Return true if any descendant is selected. This method does not check all nodes recursively. Instead, on each modification of the tree, internal flags are updated and the information is propagated upwards in the tree.

  Complexity: O(1)

Returns
  bool true if any node in the subtree is selected

## count()

Size BALL::Composite::count | ( | const KernelPredicateType & | predicate | ) | const

Count the number of nodes fulfilling a predicate in this subtree.

Parameters

  predicate | the predicate

Returns
  Size the number of nodes in the subtree satisfying the predicate

## countDescendants()

Size BALL::Composite::countDescendants | ( |  | ) | const

Count the number of descendants.

Returns
  Size the number of descendants of this node

## deleteChildrenList_()

void BALL::Composite::deleteChildrenList_ | ( | std::list< Composite * > & | composites | ) |

## deselect()

virtual void BALL::Composite::deselect | ( |  | ) |

virtual

Deselect a composite. This method deselects the composite and all the composites therein.

  If the state of this composite is modified, its selection time stamp is updated and that of its ancestors (up to and including the root composite) as well. The time stamps of descendants that changed their selection state are update, too.

Reimplemented from BALL::Selectable.

## destroy() [1/2]

virtual void BALL::Composite::destroy | ( |  | ) |

virtual

Destroy the composite. This method removes the composite from potential parental structures and then calls clear to destruct all children.

  This method updates the modification time stamp of this.

See also
  stamp
  ~Composite
  clear

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, and BALL::SecondaryStructure.

## destroy() [2/2]

void BALL::Composite::destroy | ( | bool | virtual_destroy | ) |

Non-virtual destroy method. This method behaves exactly like destroy except for a small difference: when called with true, it calls the virtual clear function. If called with false it calls the original clear function of Composite. This is useful when implementing the behaviour of derived classes.

  This method updates the modification time stamp of this.

See also
  stamp

Parameters

  virtual_destroy | call the virtual clear method (true) or Composite::clear() (false)

## dump()

virtual void BALL::Composite::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Dump the constent of this instance to an ostream.

Parameters

  s | the stream to which we will dump
  depth | the indentation depth of the output

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Chain, BALL::Fragment, BALL::Molecule, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, and BALL::SecondaryStructure.

## endAncestor() [1/2]

AncestorIterator BALL::Composite::endAncestor | ( |  | ) |

inline

Definition at line 1058 of file composite.h.

## endAncestor() [2/2]

AncestorConstIterator BALL::Composite::endAncestor | ( |  | ) | const

inline

Definition at line 1071 of file composite.h.

## endChildComposite() [1/2]

ChildCompositeIterator BALL::Composite::endChildComposite | ( |  | ) |

inline

Definition at line 1179 of file composite.h.

## endChildComposite() [2/2]

ChildCompositeConstIterator BALL::Composite::endChildComposite | ( |  | ) | const

inline

Definition at line 1196 of file composite.h.

## endComposite() [1/2]

CompositeIterator BALL::Composite::endComposite | ( |  | ) |

inline

Definition at line 1472 of file composite.h.

## endComposite() [2/2]

CompositeConstIterator BALL::Composite::endComposite | ( |  | ) | const

inline

Definition at line 1482 of file composite.h.

## get()

void BALL::Composite::get | ( | Composite & | composite,
|  | bool | deep = true ) const

Assignment of a tree to another. Create a deep (deep = true) or shallow copy of a composite and assign it to composite. composite is destroyed first.

Parameters

  composite | the composite to assign the copy to
  deep | true for a deep copy

## getAncestor() [1/4]

template<typename T>

BALL_INLINE T * BALL::Composite::getAncestor | ( | const T & |  | ) |

Definition at line 2063 of file composite.h.

## getAncestor() [2/4]

template<typename T>

T * BALL::Composite::getAncestor | ( | const T & |  | ) |

Find the first ancestor of type T. This method walks up the tree from parent to parent and checks whether the composite object is a kind of T. This method is useful to identify special container classes.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found up to the root of the tree

## getAncestor() [3/4]

template<typename T>

BALL_INLINE const T * BALL::Composite::getAncestor | ( | const T & |  | ) | const

Definition at line 2083 of file composite.h.

## getAncestor() [4/4]

template<typename T>

const T * BALL::Composite::getAncestor | ( | const T & |  | ) | const

Find the first ancestor of type T (const method). This method operates also on constant trees.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found to the root of the tree

## getChild() [1/2]

Composite * BALL::Composite::getChild | ( | Index | index | ) |

Return the index th child of this composite. If no such child exists, 0 is returned. The index of the first child is 0.

Parameters

  index | the index of the child to return

Returns
  a pointer to the child or 0 if there is no such child.

## getChild() [2/2]

const Composite * BALL::Composite::getChild | ( | Index | index | ) | const

Return a const pointer to the index th child of this composite. If no such child exists, 0 is returned. The index of the first child is 0.

Parameters

  index | the index of the child to return

Returns
  a const pointer to the child or 0 if there is no such child.

## getDegree()

Size BALL::Composite::getDegree | ( |  | ) | const

Return the degree of the node. This method returns the number of children of a composite object.

Returns
  Size the number of children

## getDepth()

Size BALL::Composite::getDepth | ( |  | ) | const

Get the depth of this item in its tree. The depth of a root item is 0.

Returns
  Size the depth

## getFirstChild() [1/2]

Composite * BALL::Composite::getFirstChild | ( |  | ) |

Return a pointer to the first child.

Returns
  a pointer to the first child or 0 if there is no child.

## getFirstChild() [2/2]

const Composite * BALL::Composite::getFirstChild | ( |  | ) | const

Return a const pointer to the first child.

Returns
  a const pointer to the first child or 0 if there is no child.

## getHeight()

Size BALL::Composite::getHeight | ( |  | ) | const

Get the height of this item in its tree. The hight of a leaf is 0.

Returns
  Size the height

## getLastChild() [1/2]

Composite * BALL::Composite::getLastChild | ( |  | ) |

Return a pointer to the last child.

Returns
  a pointer to the last child or 0 if there is no child.

## getLastChild() [2/2]

const Composite * BALL::Composite::getLastChild | ( |  | ) | const

Return a const pointer to the last child.

Returns
  a const pointer to the last child or 0 if there is no child.

## getLowestCommonAncestor() [1/2]

Composite * BALL::Composite::getLowestCommonAncestor | ( | const Composite & | composite | ) |

Get the lowest common ancestor of this item with an other. If no common ancestor exists 0 is returned.

Returns
  Composite& the lowest common ancestor

## getLowestCommonAncestor() [2/2]

const Composite * BALL::Composite::getLowestCommonAncestor | ( | const Composite & | composite | ) | const

Get a const reference to the lowest common ancestor of this item with an other. If no common ancestor exists, 0 is returned.

Returns
  Composite& the lowest common ancestor

## getModificationTime()

const PreciseTime & BALL::Composite::getModificationTime | ( |  | ) | const

Return the time of last modification

Returns
  the last modification time

## getNext() [1/4]

template<typename T>

BALL_INLINE T * BALL::Composite::getNext | ( | const T & |  | ) |

Definition at line 2144 of file composite.h.

## getNext() [2/4]

template<typename T>

T * BALL::Composite::getNext | ( | const T & |  | ) |

Find the next composite of type T. This method walks backward in the tree from composite to composite and checks whether the composite object is a kind of T.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found up to the root of the tree

## getNext() [3/4]

template<typename T>

BALL_INLINE const T * BALL::Composite::getNext | ( | const T & | dummy | ) | const

Definition at line 2174 of file composite.h.

## getNext() [4/4]

template<typename T>

const T * BALL::Composite::getNext | ( | const T & | dummy | ) | const

Find the next composite of type T (const method). This method walks backward in the tree from composite to composite and checks whether the composite object is a kind of T.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found up to the root of the tree

## getParent() [1/2]

Composite * BALL::Composite::getParent | ( |  | ) |

Return the composite's parent.

Returns
  a pointer to the parent composite or 0 if no parent exists

## getParent() [2/2]

const Composite * BALL::Composite::getParent | ( |  | ) | const

Return the composite's parent (const method).

Returns
  a pointer to the parent composite or 0 if no parent exists

## getPathLength()

Size BALL::Composite::getPathLength | ( | const Composite & | composite | ) | const

Get the length of the path between two composite objects. If no path exists INVALID_Size is returned.

Parameters

  composite | the second object

Returns
  Size the size of the path

## getPrevious() [1/4]

template<typename T>

BALL_INLINE T * BALL::Composite::getPrevious | ( | const T & |  | ) |

Definition at line 2101 of file composite.h.

## getPrevious() [2/4]

template<typename T>

T * BALL::Composite::getPrevious | ( | const T & |  | ) |

Find the nearest previous composite of type T. This method walks backward in the tree from composite to composite and checks whether the composite object is a kind of T.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found up to the root of the tree

## getPrevious() [3/4]

template<typename T>

BALL_INLINE const T * BALL::Composite::getPrevious | ( | const T & | dummy | ) | const

Definition at line 2133 of file composite.h.

## getPrevious() [4/4]

template<typename T>

const T * BALL::Composite::getPrevious | ( | const T & | dummy | ) | const

Find the nearest previous composite of type T (const method). This method walks backward in the tree from composite to composite and checks whether the composite object is a kind of T.

Returns
  a pointer to the first composite found that is a kind of T or 0 if no matching composite was found up to the root of the tree

## getRoot() [1/2]

Composite & BALL::Composite::getRoot | ( |  | ) |

Get the root of this item.

Returns
  Composite& the root

## getRoot() [2/2]

const Composite & BALL::Composite::getRoot | ( |  | ) | const

Get a const reference to the root of this item.

Returns
  Composite& the root

## getSelectionTime()

const PreciseTime & BALL::Composite::getSelectionTime | ( |  | ) | const

Return the time of last change of selection.

Returns
  the last time of change of selection

## getSibling() [1/2]

Composite * BALL::Composite::getSibling | ( | Index | index | ) |

Return a pointer to the sibling index positions from this composite. A pointer to the sibling index positions to the right (for positive values of index) or -index positions to the left (for negative values of index) is returned. For Index = 0 the this-pointer is returned.

Parameters

  index | the index of the sibling

Returns
  a pointer to the child or 0 if there is no such sibling.

## getSibling() [2/2]

const Composite * BALL::Composite::getSibling | ( | Index | index | ) | const

Return a const pointer to the sibling index positions from this composite. A pointer to the sibling index positions to the right (for positive values of index) or -index positions to the left (for negative values of index) is returned. For Index = 0 the this-pointer is returned.

Parameters

  index | the index of the sibling

Returns
  a const pointer to the child or 0 if there is no such sibling.

## hasAncestor() [1/2]

template<typename T>

BALL_INLINE bool BALL::Composite::hasAncestor | ( | const T & | dummy | ) | const

Definition at line 2185 of file composite.h.

## hasAncestor() [2/2]

template<typename T>

bool BALL::Composite::hasAncestor | ( | const T & | dummy | ) | const

Return true if the node has a ancestor of the same type as dummy.

## hasChild()

bool BALL::Composite::hasChild | ( |  | ) | const

Return true if the node has a child.

## hasNextSibling()

bool BALL::Composite::hasNextSibling | ( |  | ) | const

Return true if the node has a previous sibling. (Its parent has a child after this.)

## hasParent()

bool BALL::Composite::hasParent | ( |  | ) | const

Return true if the node has a parent.

## hasPreviousSibling()

bool BALL::Composite::hasPreviousSibling | ( |  | ) | const

Return true if the node has a previous sibling. (Its parent has a child before this.)

## hasSibling()

bool BALL::Composite::hasSibling | ( |  | ) | const

Return true if the node has a sibling. (Its parent has other childs.)

## host()

void BALL::Composite::host | ( | Visitor< Composite > & | visitor | ) |

Visitor host method. Composites may be visited. For an example look into Composite_test.C

Parameters

  visitor | the visitor

Exceptions

  Exception::GeneralException |

## insertAfter()

void BALL::Composite::insertAfter | ( | Composite & | composite | ) |

Insert a node after this node. This method inserts composite after this node, if this node has a parent and is not a descendant of composite. Self-insertion is recognized and ignored (nothing is done).

  This method updates the modification time stamp.

See also
  stamp

Parameters

  composite | the node to be inserted in the tree after of this

## insertBefore()

void BALL::Composite::insertBefore | ( | Composite & | composite | ) |

Insert a node before this node. This method inserts composite before this node, if this node has a parent and is not a descendant of composite. Self-insertion is recognized and ignored (nothing is done).

  This method updates the modification time stamp.

See also
  stamp

Parameters

  composite | the node to be inserted in the tree before this

## insertParent()

bool BALL::Composite::insertParent | ( | Composite & | parent,
|  | Composite & | first,
|  | Composite & | last,
|  | bool | destroy_parent = true )

static

Insert a new parent node. This method is used to combine a range of nodes into a single parent. First, the parent composite is destroyed. Then, all nodes from first through last are inserted into parent and parent is inserted in the former position of first. The method returns false, if {\tt first} or last have differing parents, if parent is identical with either first or last, or if first is already a descendant of parent.

  This method updates the modification time stamp.

See also
  stamp

Parameters

  parent | the new parent of the nodes from first through last
  first | the first of the nodes to be inserted into parent
  last | the last of the nodes to be inserted into parent
  destroy_parent | keeps the current contents of parent if set to true

## isAncestorOf()

bool BALL::Composite::isAncestorOf | ( | const Composite & | composite | ) | const

Return true if the node has composite as descendent.

## isAtom()

virtual bool BALL::Composite::isAtom | ( |  | ) | const

inline virtual

Test if the Composite is an Atom

Reimplemented in BALL::Atom.

Definition at line 757 of file composite.h.

## isChain()

virtual bool BALL::Composite::isChain | ( |  | ) | const

inline virtual

Test if the Composite is a Chain

Reimplemented in BALL::Chain.

Definition at line 782 of file composite.h.

## isChildOf()

bool BALL::Composite::isChildOf | ( | const Composite & | composite | ) | const

Return true if the node has the parent composite.

## isDescendantOf()

bool BALL::Composite::isDescendantOf | ( | const Composite & | composite | ) | const

Return true if the node is a descendent of composite.

## isEmpty()

bool BALL::Composite::isEmpty | ( |  | ) | const

Return true if the node does not contain children.

Returns
  bool true if number_of_children_ == 0

## isFirstChild()

bool BALL::Composite::isFirstChild | ( |  | ) | const

Return true if the node is the first child of its parent.

## isFirstChildOf()

bool BALL::Composite::isFirstChildOf | ( | const Composite & | composite | ) | const

Return true if the node is the first child of composite.

## isFragment()

virtual bool BALL::Composite::isFragment | ( |  | ) | const

inline virtual

Test if the Composite is a Fragment

Reimplemented in BALL::Fragment.

Definition at line 772 of file composite.h.

## isHomomorph()

bool BALL::Composite::isHomomorph | ( | const Composite & | composite | ) | const

Return true if composite is homomorph to this node. (The subtrees of the two instances have to be of the same form.)

## isInterior()

bool BALL::Composite::isInterior | ( |  | ) | const

Return true if the node is not the root or a leaf.

## isLastChild()

bool BALL::Composite::isLastChild | ( |  | ) | const

Return true if the node is the last child of its parent.

## isLastChildOf()

bool BALL::Composite::isLastChildOf | ( | const Composite & | composite | ) | const

Return true if the node is the last child of composite.

## isMolecule()

virtual bool BALL::Composite::isMolecule | ( |  | ) | const

inline virtual

Test if the Composite is a Molecule

Reimplemented in BALL::Molecule.

Definition at line 762 of file composite.h.

## isNextSiblingOf()

bool BALL::Composite::isNextSiblingOf | ( | const Composite & | composite | ) | const

Return true if the node is a next sibling of composite.

## isParentOf()

bool BALL::Composite::isParentOf | ( | const Composite & | composite | ) | const

Return true if the node is the parent of composite.

## isPreviousSiblingOf()

bool BALL::Composite::isPreviousSiblingOf | ( | const Composite & | composite | ) | const

Return true if the node is a previous sibling of composite.

## isProtein()

virtual bool BALL::Composite::isProtein | ( |  | ) | const

inline virtual

Test if the Composite is a Protein

Reimplemented in BALL::Protein.

Definition at line 767 of file composite.h.

## isRelatedWith()

bool BALL::Composite::isRelatedWith | ( | const Composite & | composite | ) | const

Return true if the node has composite as ancestor or composite is ancestor of this node.

## isResidue()

virtual bool BALL::Composite::isResidue | ( |  | ) | const

inline virtual

Test if the Composite is a Residue

Reimplemented in BALL::Residue.

Definition at line 777 of file composite.h.

## isRoot()

bool BALL::Composite::isRoot | ( |  | ) | const

Return true if the node has no parent.

Returns
  bool true if parent_ == 0

## isRootOf()

bool BALL::Composite::isRootOf | ( | const Composite & | composite | ) | const

Return true if the node is root of composite.

## isSiblingOf()

bool BALL::Composite::isSiblingOf | ( | const Composite & | composite | ) | const

Return true if the node is a sibling of composite.

## isValid()

virtual bool BALL::Composite::isValid | ( |  | ) | const

virtual

Test if the subtree with this node as root is valid. (The structure of the subtree has to be valid.)

Reimplemented from BALL::Object.

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::NucleicAcid, BALL::Nucleotide, BALL::Protein, BALL::Residue, and BALL::SecondaryStructure.

## operator!=()

bool BALL::Composite::operator!= | ( | const Composite & | composite | ) | const

Inequality operator.

See also
  operator == B

## operator=()

Composite & BALL::Composite::operator= | ( | const Composite & | composite | ) |

Assignment operator.

Parameters

  composite | the Composite tree to assign from

Returns
  a const reference to this

## operator==()

bool BALL::Composite::operator== | ( | const Composite & | composite | ) | const

Equality operator. Compares the handles of two Composite objects, therefore two Composite objects can never be equal.

See also
  Object::operator ==

Parameters

  composite | the composite against which equality will be tested

## persistentRead()

virtual void BALL::Composite::persistentRead | ( | PersistenceManager & | pm | ) |

virtual

Read a persistent object.

Parameters

  pm | the persistence manager

Exceptions

  Exception::GeneralException |

Reimplemented from BALL::PersistentObject.

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Chain, BALL::Fragment, BALL::Molecule, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, BALL::SecondaryStructure, and BALL::System.

## persistentWrite()

virtual void BALL::Composite::persistentWrite | ( | PersistenceManager & | pm,
|  | const char * | name = 0 ) const

virtual

Write a persistent copy of the object.

Parameters

  pm | the persistence manager
  name | the object name

Exceptions

  Exception::GeneralException |

Reimplemented from BALL::PersistentObject.

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Chain, BALL::Fragment, BALL::Molecule, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, BALL::SecondaryStructure, and BALL::System.

## prependChild()

void BALL::Composite::prependChild | ( | Composite & | composite | ) |

Insert a composite as the first child of this composite. Updates the modification time stamp.

See also
  stamp

Parameters

  composite | the composite to be inserted

## rbeginChildComposite() [1/2]

ChildCompositeReverseIterator BALL::Composite::rbeginChildComposite | ( |  | ) |

inline

Definition at line 1206 of file composite.h.

## rbeginChildComposite() [2/2]

ChildCompositeConstReverseIterator BALL::Composite::rbeginChildComposite | ( |  | ) | const

inline

Definition at line 1220 of file composite.h.

## rbeginComposite() [1/2]

CompositeReverseIterator BALL::Composite::rbeginComposite | ( |  | ) |

inline

Definition at line 1490 of file composite.h.

## rbeginComposite() [2/2]

CompositeConstReverseIterator BALL::Composite::rbeginComposite | ( |  | ) | const

inline

Definition at line 1503 of file composite.h.

## removeChild()

bool BALL::Composite::removeChild | ( | Composite & | child | ) |

Remove a child from its parent. child is only removed, if it is a true child of this.

  This method updates the modification time stamp of this.

See also
  stamp

Parameters

  child | the child to remove

Returns
  false if child could not be removed

## removeSelected()

Size BALL::Composite::removeSelected | ( |  | ) |

Remove selected subcomposites. This method iterates over all children of the current composite and removes all selected composites by deleteing them. If the respective Composite are not AutoDeletable, they are just d from the hierarchy, but not deleted. This method is useful in combination with the Selector class in order to remove unwanted partitions of kernel data structures.

Returns
  the number of composites deleted.

## removeUnselected()

Size BALL::Composite::removeUnselected | ( |  | ) |

Remove unselected subcomposites. This method iterates over all children of the current composite and removes all unselected composites by deleteing them. If the respective Composite are not AutoDeletable, they are just d from the hierarchy, but not deleted. This method is useful in combination with the Selector class in order to remove unwanted partitions of kernel data structures.

Returns
  the number of composites deleted.

## rendChildComposite() [1/2]

ChildCompositeReverseIterator BALL::Composite::rendChildComposite | ( |  | ) |

inline

Definition at line 1211 of file composite.h.

## rendChildComposite() [2/2]

ChildCompositeConstReverseIterator BALL::Composite::rendChildComposite | ( |  | ) | const

inline

Definition at line 1225 of file composite.h.

## rendComposite() [1/2]

CompositeReverseIterator BALL::Composite::rendComposite | ( |  | ) |

inline

Definition at line 1495 of file composite.h.

## rendComposite() [2/2]

CompositeConstReverseIterator BALL::Composite::rendComposite | ( |  | ) | const

inline

Definition at line 1508 of file composite.h.

## replace()

void BALL::Composite::replace | ( | Composite & | composite | ) |

This instance and its subtree is removed form its tree and replaced by composite and its subtree.

  This method updates the modification time stamp of this and composite.

See also
  stamp

Parameters

  composite | the composite which will be inserted

## select()

virtual void BALL::Composite::select | ( |  | ) |

virtual

Select a composite. This method selects the composite and all the composites therein.

  If the state of this composite is modified, its selection time stamp is updated and that of its ancestors (up to and including the root composite) as well. The time stamps of descendants that changed their selection state are update, too.

Reimplemented from BALL::Selectable.

## set()

void BALL::Composite::set | ( | const Composite & | composite,
|  | bool | deep = true )

Assignment.

Parameters

  composite | the Composite tree to assign from
  deep | a bool deciding whether the assignment will be deep or shallow.

## splice()

void BALL::Composite::splice | ( | Composite & | composite | ) |

Insert the children of composite into this composite. The children of composite are inserted at the position of composite if composite is a child of this. Otherwise the children are inserted using spliceBefore .

  This method updates the modification time stamp.

See also
  stamp

Parameters

  composite | the composite to be spliced

## spliceAfter()

void BALL::Composite::spliceAfter | ( | Composite & | composite | ) |

Append all children of composite to the children of this composite. The method does nothing, if composite is identical to this or is a descendent of this.

  This method updates the modification time stamp.

See also
  stamp

Parameters

  composite | the composite to be spliced

## spliceBefore()

void BALL::Composite::spliceBefore | ( | Composite & | composite | ) |

Prepend all children of composite to the children of this composite. The method does nothing, if composite is identical to this or is a descendent of this.

  This method updates the modification time stamp.

See also
  stamp

Parameters

  the | composite to be spliced

## stamp()

void BALL::Composite::stamp | ( | StampType | stamp = BOTH | ) |

Modify a time stamp. Update one or both of the two time stamps with the current time. The time stamp is then propagated up to the root of the composite tree. Each composite contains two stamps. the modification stamp is updated each time the tree structure changes, while the selection stamp is updated each time the selection status changes.

Parameters

  stamp | the time stamp type

## swap()

void BALL::Composite::swap | ( | Composite & | composite | ) |

Swap the contents of two composites.

  This method updates the modification time stamp of this and composite.

See also
  stamp

Parameters

  composite | the composite with which the contents will be swapped

## Friends And Related Symbol Documentation

## AncestorIteratorTraits

friend class AncestorIteratorTraits

friend

Definition at line 1048 of file composite.h.

## ChildCompositeIteratorTraits

friend class ChildCompositeIteratorTraits

friend

Definition at line 1168 of file composite.h.

## CompositeIteratorTraits

friend class CompositeIteratorTraits

friend

Definition at line 1465 of file composite.h.

## Member Data Documentation

## DEFAULT_PROCESSOR

UnaryProcessor<Composite> BALL::Composite::DEFAULT_PROCESSOR

static

Definition at line 109 of file composite.h.

## DEFAULT_UNARY_PREDICATE

KernelPredicateType BALL::Composite::DEFAULT_UNARY_PREDICATE

static

Definition at line 110 of file composite.h.